using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class SexThruster : MVRScript
{
    private static readonly bool __DEBUG__ = false;

    // Defining enum crashes VaM??
    // public enum ThrusterActions
    // {
    //     PenisAlign,
    //     MaleThrust,
    //     FemaleThrust
    // }

    // UI variables
    private JSONStorableBool _isActiveJSON;
    private JSONStorableStringChooser _maleAtomJSON;
    private JSONStorableStringChooser _femaleAtomJSON;
    private JSONStorableBool _penisAlignEnabledJSON;
    private JSONStorableBool _maleThrustEnabledJSON;
    private JSONStorableBool _femaleThrustEnabledJSON;
    private JSONStorableFloat _cycleDurationJSON;
    private JSONStorableFloat _cyclePctInJSON;
    private JSONStorableFloat _cycleDurationRandomJSON;
    private JSONStorableFloat _cycleDurationUpdateIntervalJSON;
    private JSONStorableStringChooser _easingInJSON;
    private JSONStorableStringChooser _easingOutJSON;

    private JSONStorableFloat _malePositionInJSON;
    private JSONStorableFloat _malePositionOutJSON;
    private JSONStorableFloat _femalePositionInJSON;
    private JSONStorableFloat _femalePositionOutJSON;
    private JSONStorableFloat _penisRotationOffsetJSON;



    // Person atoms, controls, colliders
    private Atom _maleAtom = null;
    private FreeControllerV3 _penisBaseControl;
    private FreeControllerV3 _penisMidControl;
    private FreeControllerV3 _penisTipControl;
    private Rigidbody _chestControl_M;
    private List<FreeControllerV3> _ctrlsMale;

    private Atom _femaleAtom = null;
    private FreeControllerV3 _hipControl_F;
    private FreeControllerV3 _abdomenControl_F;
    private Rigidbody _vaginaTrigger;
    private Rigidbody _deeperVaginaTrigger;
    private List<FreeControllerV3> _ctrlsFemale;



    // Variables
    private float _currCycleTime = 0.0f;
    private float _currCycleDuration;
    private Vector3 _penisTarget;
    private Vector3 _penisStart;
    private Vector3 _penisAngleOffset;
    private Vector3 _hipTarget;
    private Vector3 _hipStart;
    private Coroutine _co_thrust = null;
    private bool _reverse = false;


    // Temporary controller save/restore settings
    public struct CtrlSettings
    {
        public FreeControllerV3.PositionState currentPositionState;
        public FreeControllerV3.RotationState currentRotationState;
        public float RBHoldPositionSpring;
        public float RBHoldRotationSpring;
        public Vector3 position;
        public Quaternion rotation;

        public CtrlSettings(FreeControllerV3 controller)
        {
            currentPositionState = controller.currentPositionState;
            currentRotationState = controller.currentRotationState;
            RBHoldPositionSpring = controller.RBHoldPositionSpring;
            RBHoldRotationSpring = controller.RBHoldRotationSpring;
            position = controller.transform.position;
            rotation = controller.transform.rotation;
        }

    }

    private readonly Dictionary<string, Dictionary<FreeControllerV3, CtrlSettings>> _savedCtrlSettings = new Dictionary<string, Dictionary<FreeControllerV3, CtrlSettings>> { };


    // Getters
    private bool _isValid => _maleAtom != null && _femaleAtom != null;
    private bool _isThrustActive => _isActiveJSON.val && _isValid && (_maleThrustEnabledJSON.val || _femaleThrustEnabledJSON.val);
    private float _currCycleMult => _reverse
                                    ? Mathf.Clamp(1.0f - _cyclePctInJSON.val, 0.1f, 0.9f)
                                    : Mathf.Clamp(_cyclePctInJSON.val, 0.1f, 0.9f);

    // Called by game engine on initialization
    public override void Init()
    {
        try
        {
            SetupUI();
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(SexThruster)}.{nameof(Init)}: {e}");
        }
    }

    // Called by game engine before first update
    private void Start()
    {
        // Assign callbacks
        new List<JSONStorableBool> {
            _isActiveJSON,
            _maleThrustEnabledJSON,
            _femaleThrustEnabledJSON,
            _penisAlignEnabledJSON
            }.ForEach(b => b.setCallbackFunction = Activate);

        _cycleDurationJSON.setCallbackFunction = f =>
        {
            _currCycleDuration = f;
        };

        ResetCycleDuration();
        Activate();

    }

    // Called by game engine each frame
    void Update()
    {
        if (_isActiveJSON.val && _isValid)
        {
            if (_penisAlignEnabledJSON.val) UpdatePenisRotation();
        }
    }


    private void Activate(bool _ = true)
    {
        if (__DEBUG__) SuperController.LogMessage($"Activating...ThrustActive = {_isThrustActive}");

        LoadMaleAtom(_maleAtomJSON.val);
        LoadFemaleAtom(_femaleAtomJSON.val);

        UpdateControlSettings();
        if (__DEBUG__) SuperController.LogMessage($"ThrustActive = {_isThrustActive}");
        if (_isThrustActive)
        {
            StartThrust();
            InvokeRepeating("ResetCycleDuration", _cycleDurationUpdateIntervalJSON.val, _cycleDurationUpdateIntervalJSON.val);
        }
        else
        {
            StopThrust();
            CancelInvoke("ResetCycleDuration");
        }

    }

    private void ResetCycleDuration()
    {
        _currCycleDuration = NewCycleDuration();
    }

    private IEnumerator Thrust()
    {
        SetTargets(_reverse);

        float _duration = _currCycleDuration * _currCycleMult;

        while (_currCycleTime <= _duration)
        {
            float t = _Utils.EasingFuncs[_reverse ? _easingOutJSON.val : _easingInJSON.val](_currCycleTime / _duration);

            if (_maleThrustEnabledJSON.val) _penisBaseControl.transform.position = Vector3.Lerp(_penisStart, _penisTarget, t);
            if (_femaleThrustEnabledJSON.val) _hipControl_F.transform.position = Vector3.Lerp(_hipStart, _hipTarget, t);

            _currCycleTime += Time.deltaTime;
            yield return null;
        }

        OnThrustEnd();
    }

    private void OnThrustEnd()
    {
        _co_thrust = null;

        if (_isThrustActive)
        {
            _reverse = !_reverse;
            StartThrust();
        }
    }

    private void StartThrust()
    {
        if (__DEBUG__) SuperController.LogMessage($"Called StartThrust: _co_thrust = {_co_thrust}");
        if (_co_thrust == null)
        {
            if (__DEBUG__) SuperController.LogMessage("Starting thrust...");
            _currCycleTime = 0.0f;
            _co_thrust = StartCoroutine(Thrust());
        }
    }

    private void StopThrust()
    {
        StopAllCoroutines();
        _co_thrust = null;
    }

    protected void LoadFemaleAtom(string atomUID)
    {
        try
        {
            _femaleAtom = SuperController.singleton.GetAtomByUid(atomUID);
            _hipControl_F = _femaleAtom.freeControllers.First(fc => fc.name == "hipControl");
            _abdomenControl_F = _femaleAtom.freeControllers.First(fc => fc.name == "abdomenControl");
            _vaginaTrigger = _femaleAtom.rigidbodies.First(rb => rb.name == "VaginaTrigger");
            _deeperVaginaTrigger = _femaleAtom.rigidbodies.First(rb => rb.name == "DeeperVaginaTrigger");

            _ctrlsFemale = new List<FreeControllerV3> { _hipControl_F };
        }
        catch (Exception e)
        {
            SuperController.LogMessage($"{nameof(SexThruster)}: Female atom is invalid.");
            // SuperController.LogError($"{nameof(SexThruster)}.{nameof(LoadFemaleAtom)}: {e}");
        }
    }

    protected void LoadMaleAtom(string atomUID)
    {
        try
        {
            _maleAtom = SuperController.singleton.GetAtomByUid(atomUID);
            _penisBaseControl = _maleAtom.freeControllers.First(fc => fc.name == "penisBaseControl");
            _penisMidControl = _maleAtom.freeControllers.First(fc => fc.name == "penisMidControl");
            _penisTipControl = _maleAtom.freeControllers.First(fc => fc.name == "penisTipControl");
            _chestControl_M = _maleAtom.rigidbodies.First(rb => rb.name == "chestControl");

            _ctrlsMale = new List<FreeControllerV3> { _penisBaseControl, _penisMidControl, _penisTipControl };
        }
        catch (Exception e)
        {
            SuperController.LogMessage($"{nameof(SexThruster)}: Male atom is invalid.");
            // SuperController.LogError($"{nameof(SexThruster)}.{nameof(LoadMaleAtom)}: {e}");
        }
    }

    // Animation methods
    private void UpdateControlSettings()
    {

        if (_isActiveJSON.val && _penisAlignEnabledJSON.val)
        {
            if (__DEBUG__) SuperController.LogMessage($"Setting Controls: PenisAlign");
            SaveControlSettings("PenisAlign");
            _penisBaseControl.currentRotationState = FreeControllerV3.RotationState.On;
            _penisMidControl.currentRotationState = FreeControllerV3.RotationState.On;
            _penisTipControl.currentRotationState = FreeControllerV3.RotationState.On;
            _penisBaseControl.RBHoldRotationSpring = 8000;
        }
        else
        {
            if (__DEBUG__) SuperController.LogMessage($"Restoring Controls: PenisAlign");
            RestoreControlSettings("PenisAlign");
        }


        if (_isActiveJSON.val && _maleThrustEnabledJSON.val)
        {
            if (__DEBUG__) SuperController.LogMessage($"Setting Controls: MaleThrust");
            SaveControlSettings("MaleThrust");
            _penisBaseControl.currentPositionState = FreeControllerV3.PositionState.On;
            _penisMidControl.currentPositionState = FreeControllerV3.PositionState.Off;
            _penisTipControl.currentPositionState = FreeControllerV3.PositionState.Off;
            _penisBaseControl.RBHoldPositionSpring = 10000;
        }
        else
        {
            if (__DEBUG__) SuperController.LogMessage($"Restoring Controls: MaleThrust");
            RestoreControlSettings("MaleThrust");
        }


        if (_isActiveJSON.val && _femaleThrustEnabledJSON.val)
        {
            if (__DEBUG__) SuperController.LogMessage($"Setting Controls: FemaleThrust");
            SaveControlSettings("FemaleThrust");
            _hipControl_F.currentPositionState = FreeControllerV3.PositionState.On;
            _hipControl_F.RBHoldPositionSpring = 6000;

        }
        else
        {
            if (__DEBUG__) SuperController.LogMessage($"Restoring Controls: FemaleThrust");
            RestoreControlSettings("FemaleThrust");
        }


    }

    private Dictionary<FreeControllerV3, CtrlSettings> GetControlSettings(List<FreeControllerV3> ctrls)
    {
        Dictionary<FreeControllerV3, CtrlSettings> outDict = new Dictionary<FreeControllerV3, CtrlSettings> { };
        foreach (var ctrl in ctrls)
        {
            outDict[ctrl] = new CtrlSettings(ctrl);
        }

        return outDict;
    }

    private void SaveControlSettings(string action)
    {
        switch (action)
        {
            case "MaleThrust":
            case "PenisAlign":
                {
                    if (!_savedCtrlSettings.ContainsKey(action))
                        _savedCtrlSettings[action] = GetControlSettings(_ctrlsMale);
                    break;
                }
            case "FemaleThrust":
                {
                    if (!_savedCtrlSettings.ContainsKey(action))
                        _savedCtrlSettings[action] = GetControlSettings(_ctrlsFemale);
                    break;
                }
        }

    }

    private void RestoreControlSettings(string action)
    {
        switch (action)
        {
            case "MaleThrust":
            case "FemaleThrust":
                {
                    if (_savedCtrlSettings.ContainsKey(action))
                    {
                        foreach (KeyValuePair<FreeControllerV3, CtrlSettings> item in _savedCtrlSettings[action])
                        {
                            item.Key.currentPositionState = item.Value.currentPositionState;
                            item.Key.transform.position = item.Value.position;
                            item.Key.RBHoldPositionSpring = item.Value.RBHoldPositionSpring;
                        }
                        _savedCtrlSettings.Remove(action);
                    }
                    break;
                }
            case "PenisAlign":
                {
                    if (_savedCtrlSettings.ContainsKey(action))
                    {
                        foreach (KeyValuePair<FreeControllerV3, CtrlSettings> item in _savedCtrlSettings[action])
                        {
                            item.Key.currentRotationState = item.Value.currentRotationState;
                            item.Key.transform.rotation = item.Value.rotation;
                            item.Key.RBHoldRotationSpring = item.Value.RBHoldRotationSpring;
                        }
                        _savedCtrlSettings.Remove(action);
                    }
                    break;
                }
        }
    }

    private float NewCycleDuration() => _cycleDurationRandomJSON.val > 0.0f
        ? Math.Max(UnityEngine.Random.Range(_cycleDurationJSON.val - _cycleDurationRandomJSON.val, _cycleDurationJSON.val + _cycleDurationRandomJSON.val), 0.1f)
        : Math.Max(_cycleDurationJSON.val, 0.1f);


    private void UpdatePenisRotation()
    {
        Vector3 _lookTarget = _deeperVaginaTrigger.transform.position;
        Vector3 _upTarget = _chestControl_M.transform.position - _penisBaseControl.transform.position;

        _penisBaseControl.transform.LookAt(_lookTarget, _upTarget);
        _penisMidControl.transform.LookAt(_lookTarget, _upTarget);
        _penisTipControl.transform.LookAt(_lookTarget, _upTarget);

        if (_penisRotationOffsetJSON.val != 0.0f)
            _penisBaseControl.transform.localEulerAngles += new Vector3(_penisRotationOffsetJSON.val, 0.0f, 0.0f);
    }

    private Vector3 GetTargetPosition(float t, bool penis = true)
    {
        Vector3 pos0 = penis ? _vaginaTrigger.transform.position : _penisBaseControl.transform.position;
        Vector3 direction = penis ? (_deeperVaginaTrigger.transform.position - _vaginaTrigger.transform.position).normalized : -_penisBaseControl.transform.forward;

        return pos0 + direction * t / 10;
    }

    private void SetTargets(bool reverse = false)
    {
        _penisStart = _penisBaseControl.transform.position;
        _penisTarget = GetTargetPosition(reverse ? _malePositionOutJSON.val : _malePositionInJSON.val);

        _hipStart = _hipControl_F.transform.position;
        _hipTarget = GetTargetPosition(reverse ? _femalePositionOutJSON.val : _femalePositionInJSON.val, false);
    }


    // UI Methods
    private void SetupUI()
    {

        _isActiveJSON = _Utils.SetupToggle(this, "<color=#1010A0><size=32><b>Active</b></size></color>", false);

        // Atoms
        _maleAtomJSON = new JSONStorableStringChooser("MaleAtom", _Utils.PersonNames, null, "Male");
        RegisterStringChooser(_maleAtomJSON);
        _maleAtomJSON.setCallbackFunction += LoadMaleAtom;
        CreateScrollablePopup(_maleAtomJSON).popup.onOpenPopupHandlers += () => { _maleAtomJSON.choices = _Utils.PersonNames; };
        _femaleAtomJSON = new JSONStorableStringChooser("FemaleAtom", _Utils.PersonNames, null, "Female");
        RegisterStringChooser(_femaleAtomJSON);
        _femaleAtomJSON.setCallbackFunction += LoadFemaleAtom;
        CreateScrollablePopup(_femaleAtomJSON).popup.onOpenPopupHandlers += () => { _femaleAtomJSON.choices = _Utils.PersonNames; };

        // Toggles
        CreateSpacer().height = 40f;
        _penisAlignEnabledJSON = _Utils.SetupToggle(this, "Enable Penis Alignment", false);
        _maleThrustEnabledJSON = _Utils.SetupToggle(this, "Enable Male Thrust", false);
        _femaleThrustEnabledJSON = _Utils.SetupToggle(this, "Enable Female Thrust", false);

        // Settings
        // Settings - Thrust
        CreateSpacer().height = 40f;
        _cycleDurationJSON = _Utils.SetupSlider(this, "Cycle Duration", 1.0f, 0.1f, 2.0f);
        _cyclePctInJSON = _Utils.SetupSlider(this, "Cycle Duration % In", 0.5f, 0.1f, 0.9f);
        _cycleDurationRandomJSON = _Utils.SetupSlider(this, "Cycle Duration Random", 0.1f, 0.0f, 2f);
        _cycleDurationUpdateIntervalJSON = _Utils.SetupSlider(this, "Cycle Update Freq", 2.0f, 1.0f, 60.0f);
        _easingInJSON = new JSONStorableStringChooser("EaseIn", _Utils.EasingTypes, "Linear", "Ease In");
        CreateScrollablePopup(_easingInJSON);
        RegisterStringChooser(_easingInJSON);

        _easingOutJSON = new JSONStorableStringChooser("EaseOut", _Utils.EasingTypes, "Linear", "Ease Out");
        CreateScrollablePopup(_easingOutJSON);
        RegisterStringChooser(_easingOutJSON);

        // Settings - Distances
        CreateSpacer().height = 40f;
        _malePositionInJSON = _Utils.SetupSlider(this, "Male Position In", 0f, -5.0f, 5.0f);
        _malePositionOutJSON = _Utils.SetupSlider(this, "Male Position Out", -2.0f, -5.0f, 5.0f);
        _femalePositionInJSON = _Utils.SetupSlider(this, "Female Position In", 0f, -5.0f, 5.0f);
        _femalePositionOutJSON = _Utils.SetupSlider(this, "Female Position Out", -2.0f, -5.0f, 5.0f);
        // Settings - Other
        CreateSpacer().height = 40f;
        _penisRotationOffsetJSON = _Utils.SetupSlider(this, "Penis Angle Up/Down", 0f, -30f, 30f);

        // Utilities
        // CreateSpacer().height = 40f;
        // CreateButton("Apply Recommended Physics Settings").button.onClick.AddListener(ApplyPhysics);



        // Instructions
        string instructionText =
            "<color=#202020><size=36><b>Settings Information</b></size></color>\n\n" +
            "<color=#101060><b>Atoms</b></color>\n" +
            "<b>Male</b> atom must have a penis.\n" +
            "<b>Female</b> atom does not require a penis.\n\n" +

            "<color=#101060><b>Cycle Settings</b></color>\n" +
            "<b>Cycle Duration:</b> Duration of a complete <i>In</i> and <i>Out</i> motion.\n" +
            "<b>Cycle Duration % In:</b> Proportion of Cycle Duration taken by the <i>In</i> motion.\n" +
            " 0.5 = <i>In</i> and <i>Out</i> have equal duration.\n" +
            "Less than 0.5 = <i>In</i> motion is faster than <i>Out</i> motion.\n" +
            "More than 0.5 = <i>In</i> motion is slower than <i>Out</i> motion.\n" +
            "<b>Cycle Duration Random:</b> Random time added to/subtracted from Cycle Duration on each duration update.\n" +
            "<b>Cycle Update Freq:</b> Time between Cycle Duration updates.\n" +
            "<b>Ease In:</b> Easing function for <i>In</i> motion. See https://easings.net for reference.\n" +
            "<b>Ease Out:</b> Easing function for <i>Out</i> motion.\n\n" +

            "<color=#101060><b>Positions In/Out</b></color>\n" +
            "Controllers (<i>penisBaseControl</i> for Male, <i>hipControl</i> for Female) move between <i>Position In</i> and <i>Position Out</i> when thrust is enabled.\n" +
            "Negative values mean away from partner. Positive values mean toward partner.\n\n" +

            "<color=#101060><b>Other</b></color>\n" +
            "<b>Penis Angle Up/Down:</b> Vertical rotation offset applied to penis when <i>Enable Penis Alignment</i> is checked.";
        CreateTextField(new JSONStorableString("text", instructionText), true).height = 1200;

    }


}

public static class _Utils
{
    // Constants for easing functions
    private static readonly float BACK_C1 = 1.70158f;
    private static readonly float BACK_C2 = BACK_C1 + 1;
    private static readonly float BACK_C3 = BACK_C1 * 1.525f;
    private static readonly float BOUNCE_C1 = 7.5625f;
    private static readonly float BOUNCE_C2 = 2.75f;

    // Easing functions
    public static Dictionary<string, Func<float, float>> EasingFuncs = new Dictionary<string, Func<float, float>>
    {
        // Reference: https://easings.net/
        {"Linear", f => f},
        {"Quadratic In", f => (float)Math.Pow(f, 2) },
        {"Quadratic Out", f => (float)(1 - Math.Pow(1 - f, 2)) },
        {"Quadratic InOut", f => f < 0.5 ? (float)(2 * Math.Pow(f, 2)) : (float)(1 - Math.Pow(2 * (1 - f), 2) / 2) },
        {"Cubic In", f => (float)Math.Pow(f, 3) },
        {"Cubic Out", f => (float)(1 - Math.Pow(1 - f, 3)) },
        {"Cubic InOut", f => f < 0.5 ? (float)(4 * Math.Pow(f, 3)) : (float)(1 - Math.Pow(2 * (1 - f), 3) / 2) },
        {"Sinusoidal In", f => (float)(1 - Math.Cos(f * Math.PI / 2)) },
        {"Sinusoidal Out", f => (float)Math.Sin(f * Math.PI / 2) },
        {"Sinusoidal InOut", f => -(float)(Math.Cos(Math.PI * f) - 1) / 2 },
        {"Exponential In", f => f == 0 ? 0 : (float)Math.Pow(2, 10 * f - 10) },
        {"Exponential Out", f => f == 1 ? 1 : (float)(1 - Math.Pow(2, -10 * f)) },
        {"Exponential InOut", f => f == 0 || f == 1 ? f :  f < 0.5 ? (float)Math.Pow(2, 20 * f - 10) / 2 : (float)(2 - Math.Pow(2, -20 * f + 10)) / 2 },
        {"Back In", f => (float)(BACK_C2 * Math.Pow(f, 3) - BACK_C1 * Math.Pow(f, 2)) },
        {"Back Out", f => (float)(1 + BACK_C2 * Math.Pow(f - 1, 3) + BACK_C1 * Math.Pow(f - 1, 2)) },
        {"Back InOut", f => f < 0.5 ? (float)(Math.Pow(2 * f, 2) * ((BACK_C3 + 1) * 2 * f - BACK_C3)) / 2 : (float)(Math.Pow(2 * f - 2, 2) * ((BACK_C3 + 1) * (f * 2 - 2) + BACK_C3) + 2) / 2 },
        {"Bounce In", f => 1 - _bounceOut(1 - f) },
        {"Bounce Out", _bounceOut },
        {"Bounce InOut", f => f < 0.5 ? (1 - _bounceOut(1 - 2*f)) / 2 : (1 + _bounceOut(2*f - 1)) / 2 }
    };

    private static float _bounceOut(float f)
    {
        if (f < 1 / BOUNCE_C2)
            return BOUNCE_C1 * f * f;

        if (f < 2 / BOUNCE_C2)
            return BOUNCE_C1 * (f -= 1.5f / BOUNCE_C2) * f + 0.75f;

        if (f < 2.5 / BOUNCE_C2)
            return BOUNCE_C1 * (f -= 2.25f / BOUNCE_C2) * f + 0.9375f;

        return BOUNCE_C1 * (f -= 2.625f / BOUNCE_C2) * f + 0.984375f;
    }

    public static List<string> EasingTypes => EasingFuncs.Keys.ToList();

    public static List<string> PersonNames => SuperController.singleton.GetAtoms().Where(atom => atom.category == "People").Select(atom => atom.name).ToList();

    public static JSONStorableFloat SetupSlider(MVRScript script, string name, float defaultValue, float minValue, float maxValue)
    {
        JSONStorableFloat storable = new JSONStorableFloat(name, defaultValue, minValue, maxValue);
        storable.storeType = JSONStorableParam.StoreType.Full;
        script.CreateSlider(storable);
        script.RegisterFloat(storable);
        return storable;
    }

    public static JSONStorableBool SetupToggle(MVRScript script, string label, bool defaultValue)
    {
        JSONStorableBool storable = new JSONStorableBool(label, defaultValue);
        storable.storeType = JSONStorableParam.StoreType.Full;
        script.CreateToggle(storable);
        script.RegisterBool(storable);
        return storable;
    }
}